package vehicle;

import journey.City;

public abstract class Vehicle {
	private String name;
	private int passengers;
	private int speed;
	private int kmCost;

	public Vehicle(String name, int passengers, int speed, int kmCost) {
		this.name = name;
		this.passengers = passengers;
		this.speed = speed;
		this.kmCost = kmCost;
	}

	public Vehicle(Vehicle v) {
		this(v.name, v.passengers, v.speed, v.kmCost);
	}

	public int getKmCost() {
		return kmCost;
	}

	public int getPassengers() {
		return passengers;
	}

	public int getSpeed() {
		return speed;
	}

	public String getName() {
		return name;
	}

	public int nbJourneyPerDay(int distance) {
		return 24 * getSpeed() / distance;
	}

	public abstract boolean compatibleWith(City c);

	public String toString() {
		return name + " - nb passengers:" + passengers + " - speed:" + speed + " km/h" + " - cost:" + kmCost
				+ " euros/km";
	}

	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Vehicle other = (Vehicle) obj;
		if (kmCost != other.kmCost)
			return false;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		if (passengers != other.passengers)
			return false;
		if (speed != other.speed)
			return false;
		return true;
	}

}
